<script setup lang="ts">
import type { BaseLink } from '@/types/base';
import { ref } from 'vue';
import type { BlogAuthor, BlogPost } from '@/types/blog';
import { toKebabCase } from '@/utils/toKebabCase';

// Props
const props = defineProps<{
  post: BlogPost;
  authors: BlogAuthor[];
  crumbs: BaseLink[];
  readingTime: number;
}>();
// Methods
const formatDate = (dateString: string): string => {
  if (!dateString) return '';

  const date = new Date(dateString);

  if (isNaN(date.getTime())) {
    return '';
  }
  const month = date.toLocaleString('en-US', { month: 'long' });
  const day = date.getDate();
  const year = date.getFullYear();
  return `${month} ${day}, ${year}`;
};
// Data
const formattedDate = ref(formatDate(props.post.date));
const updatedDate = ref(props.post.updatedDate ? formatDate(props.post.updatedDate) : null);
</script>

<template>
  <SlpContainer class="container">
    <div class="wrapper">
      <div class="hero">
        <CommonBreadcrumbs v-if="crumbs" :crumbs="crumbs" />
        <div v-if="updatedDate || formattedDate" class="date">
          <SlpTypography variant="body2" tag="p">
            {{ updatedDate ? `Updated on ${updatedDate}` : `Published on ${formattedDate}` }}
          </SlpTypography>
          <div class="pill">
            <SlpTypography v-if="readingTime" variant="body3" tag="p">
              {{ `${readingTime} min read` }}
            </SlpTypography>
          </div>
        </div>
        <SlpTypography v-if="post.title" variant="heading2-bold" tag="h1">
          {{ post.title }}
        </SlpTypography>
        <SlpTypography v-if="post.description" variant="body1" tag="p">
          {{ post.description }}
        </SlpTypography>
        <NuxtImg :src="`${post.heroImage}`" alt="" />
      </div>
      <div class="information">
        <div v-for="author in authors" :key="author.content.name" class="author">
          <NuxtImg
            v-if="author.content.config.headshot"
            :src="author.content.config.headshot"
            :alt="author.content.name"
          />
          <a
            v-if="author"
            :href="`/blog/authors/${`${author.content.config.ctfId || toKebabCase(author.content.name)}/` || ''}`"
            :data-ga-name="`${author.content.name} link`"
            data-ga-location="hero"
          >
            <SlpTypography variant="body1">
              {{ author.content.name }}
            </SlpTypography>
          </a>
        </div>
        <div v-if="post.tags?.length" class="tags">
          <a
            v-for="tag in post.tags"
            :key="tag"
            class="pill"
            :href="`/blog/tags/${tag.replace('/', '_').replace(' ', '-').toLowerCase()}/`"
            :data-ga-name="tag.toLowerCase()"
            data-ga-location="hero"
            ><SlpTypography variant="body3" tag="p">{{ tag }}</SlpTypography></a
          >
        </div>
      </div>
    </div>
  </SlpContainer>
</template>

<style lang="scss" scoped>
.wrapper {
  padding-top: 32px;
  display: grid;
  gap: 64px;
  grid-template-columns: 70% 30%;
  @media (max-width: $breakpoint-lg) {
    grid-template-columns: 1fr;
  }
  .hero {
    display: flex;
    flex-direction: column;
    gap: 16px;
    .date {
      display: flex;
      align-items: center;
      gap: 8px;
    }
    img {
      width: 100%;
      object-fit: cover;
      margin-top: 24px;
      max-height: 500px;
    }
  }

  .information {
    padding-top: 64px;
    display: flex;
    flex-direction: column;
    gap: 24px;

    @media (min-width: $breakpoint-lg) {
      padding-top: 88px;
    }
    .author {
      display: flex;
      align-items: center;
      gap: 8px;
      img {
        width: 80px;
        height: 80px;
        border-radius: 80px;
        object-fit: contain;
      }
    }
    .tags {
      display: flex;
      gap: 8px;
      flex-wrap: wrap;
    }
  }

  :deep(a) {
    color: $color-text-link-100;
  }
}

.container {
  position: relative;
  &::after {
    content: '';
    position: absolute;
    top: 0;
    left: -40%;
    width: 140vw;
    height: 60%;
    background: linear-gradient(126deg, #eee7fd 0%, rgba(246, 243, 254, 0.83) 49.71%, rgba(255, 212, 216, 0.45) 100%);
    z-index: -1;
    @media (min-width: 2100px) {
      left: -60%;
    }
    @media (min-width: $breakpoint-lg) {
      height: 75%;
    }
  }
}
.pill {
  padding: 4px 16px;
  border-radius: 20px;
  border: 1px solid $color-surface-300;
  background: $color-surface-50;
  display: inline-block;
}
</style>
